<link rel="import" href="/bower_components/polymer/polymer.html">
<link rel="import" href="/bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="/bower_components/paper-button/paper-button.html">
<link rel="import" href="/bower_components/iron-icons/av-icons.html">
<link rel="import" href="/bower_components/iron-ajax/iron-ajax.html">
<script src="/lib/sc-musical-time.js"></script>

<dom-module id="sc-controller">

    <template>
        <paper-icon-button icon="av:play-arrow" on-tap="play"></paper-icon-button>
        <paper-icon-button icon="av:pause" on-tap="pause"></paper-icon-button>
        <paper-icon-button icon="av:stop" on-tap="stop"></paper-icon-button>

        <paper-icon-button icon="av:album" on-tap="load"></paper-icon-button>

        <select id="select-type">
            <option>MIDI</option>
            <option>MP3</option>
        </select>

        <paper-button on-tap="mute" data-staff="0">Mute 0</paper-button>
        <paper-button on-tap="mute" data-staff="1">Mute 1</paper-button>
        <paper-button on-tap="mute" data-staff="2">Mute 2</paper-button>

        <!--<paper-button on-tap="sample" data-label="mylabel1">Label 1</paper-button>
        <paper-button on-tap="sample" data-label="mylabel5">Label 5</paper-button>
        <paper-button on-tap="sample" data-label="mylabel6">Label 6</paper-button>
        <paper-button on-tap="sample" data-label="mylabel7">Label 7</paper-button>-->
    </template>

    <script>
        Polymer({

            is: 'sc-controller',
            time: new scMusicalTime.MusicalTime(100, 4),
            load() {

                let type = this.$['select-type'].value
                let source

                if (type == 'MIDI')
                    source = '/midi/1.mid'

                if (type == 'MP3')
                    source = '/mp3/02.mp3'

                this.fire('iron-signal', {
                    name: 'player-load',
                    data: { type, source }
                })
            },
            mute(event) {
                let staff = parseInt(event.target.getAttribute('data-staff'))
                this.fire('iron-signal', { name: 'player-mute', data: { channel: staff } })
            },
            // sample(event) {
            //     let key = event.target.getAttribute('data-label')
            //     let label = this.labels[key]

            //     let req = {
            //         start: this.time.toMillisecond(label.start),
            //         duration: this.time.toMillisecond(label.duration)
            //     }

            //     this.fire('iron-signal', { name: 'player-sample', data: req })
            // },
            play() {
                this.fire('iron-signal', { name: 'player-play' })
            },
            pause() {
                this.fire('iron-signal', { name: 'player-pause' })
            },
            stop() {
                this.fire('iron-signal', { name: 'player-stop' })
            }
        })
    </script>

</dom-module>
